/*
	This FODD2015 program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

var fileData={
		store:null,
		fileName:null,
		url:null,
		callback:null,
		text:null,
		appDir:null
		};
document.addEventListener("deviceready",fm_init,false);



function fm_createDirectory(path,success){
	var dirs = path.split("/").reverse();
	var root = window.FS.root;
	
	var createDir = function(dir){
		console.log("create dir " + dir);
		root.getDirectory(dir, {
			create : true,
			exclusive : false
		}, successCB, failCB);
	};
	
	var successCB = function(entry){
		console.log("dir created " + entry.fullPath);
		root = entry;
		if(dirs.length > 0){
			createDir(dirs.pop());
		}else{
			console.log("all dir created");
			if(success)
				success(entry);
		}
	};
	
	var failCB = function(){
		console.log("failed to create dir " + dir);
	};
	
	createDir(dirs.pop());
}


function fm_init()
{
	/*fileData.appDir=cordova.file.dataDirectory.replace("file:///","");
	fm_CreateAppDir();*/
};



/* FILE SYSTEM ACCESS SAVE*/
function fm_SaveFile(text,file,callback) {
	fileData.store=fileData.appDir;
	fileData.fileName=file;
	fileData.callback=callback;
	fileData.text=text;
	window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, fm_gotFSSave, fail);
}

function fm_gotFSSave(fileSystem) {
	fileSystem.root.getDirectory(fileData.store, {create: true, exclusive: false}, fm_saveFS, fail);
}

function fm_saveFS(fileSystem) {
	fileSystem.getFile(fileData.fileName, {create: true}, fm_gotWriterFileEntry, fail);
}

function fm_gotWriterFileEntry(fileEntry) {
	fileEntry.createWriter(fm_saveFile, fail);
}

function fm_saveFile(writer) {
	if(fileData.callback)
		writer.onwrite=fileData.callback;
	writer.write(fileData.text);
}

/* FILE SYSTEM ACCESS LOAD*/
function fm_LoadFile(file,callback) {
	fileData.store=fileData.appDir;
	fileData.fileName=file;
	fileData.callback=callback;
	window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, fm_gotFSLoad, fail);
}

function fm_gotFSLoad(fileSystem) {
	fileSystem.root.getDirectory(fileData.store, {create: true, exclusive: false}, fm_loadFS, fail);
}

function fm_loadFS(fileSystem) {
	fileSystem.getFile(fileData.fileName, {create: true}, fm_gotReaderFileEntry, fail);
}

function fm_gotReaderFileEntry(fileEntry) {
	fileEntry.file(fm_readFile, fail);
}

function fm_readFile(file) {
    var reader = new FileReader();
    if(fileData.callback)
    	reader.onloadend=fileData.callback;
    reader.readAsText(file);
}


/* FILE SYSTEM ACCESS APPEND*/
function fm_AppendFile(text,file,callback) {
	fileData.store=fileData.appDir;
	fileData.fileName=file;
	fileData.text=text;
	fileData.callback=callback;
	window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, fm_gotAppendFS, fail);
}

function fm_gotAppendFS(fileSystem) {
	fileSystem.root.getDirectory(fileData.store, {create: true, exclusive: false}, fm_directoryAppendFS, fail);
}

function fm_directoryAppendFS(fileSystem) {
	fileSystem.getFile(fileData.fileName, {create: true}, fm_gotAppendWriterFileEntry, fail);
}

function fm_gotAppendWriterFileEntry(fileEntry) {
	fileEntry.createWriter(fm_appendFile, fail);
}

function fm_appendFile(writer) {
    if(fileData.callback)
		writer.onwrite=fileData.callback;
    writer.seek(writer.length);
    writer.write(fileData.text);
}



/* FILE SYSTEM ACCESS DOWNLOAD*/
//es:  fm_DownloadFile("http://www.scandiccifiera.com/images/catalogo/programma2013.pdf");
function fm_DownloadFile(url) {
	fileData.store=fileData.appDir;
	fileData.url=url;
	fileData.fileName = "programma2013.pdf";
	//fileData.callback=fm_download;
	window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, fm_gotDownloadFS, fail);
}

function fm_gotDownloadFS(fileSystem) {
	fileSystem.root.getDirectory(fileData.store, {create: true, exclusive: false}, fm_download, fail);
}



function fm_download(entry) {
	console.log("About to start transfer");
	var fileTransfer = new FileTransfer();
	var store=entry.toURL();
	console.log(store);
	fileTransfer.download(encodeURI(fileData.url), store + fileData.fileName, 
		function(entry) {
			console.log("Success!");
			if(fileData.callback)
				fileData.callback(entry);
		}, 
		function(err) {
			console.log("Error");
			if(fileData.callback)
				fileData.callback(err);
		});
}

//Utility

function fm_CreateDir(store)
{
	fileData.store=store.replace("file:///","");
	window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, fm_CreateDirectory, null); 
}

function fm_CreateAppDir()
{
	fileData.store=fileData.appDir;
	fm_CreateDir(fileData.store) 
}

function fm_CreateDirectory(fileSystem) {
	window.FS = fileSystem;
	var dir=fileData.store;
	fm_createDirectory(dir,null);
}

function fm_toUrl(file)
{
	fileData.fileName=file;
	var url="file:///"+fileData.store+file;
	fileData.callback=function(entry){
		url=entry.toUrl();
	}
	window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, fm_toUrlFS, null);
	return url;
}

function fm_toUrlFS(fileSystem) {
	console.log("fm_toUrlFS");
	fileSystem.root.getDirectory(fileData.store, {create: true, exclusive: false}, fm_filetoUrlFS, fail);
}

function fm_filetoUrlFS(fileSystem) {
	console.log("fm_filetoUrlFS");
	fileSystem.getFile(fileData.fileName, {create: true}, fileData.callback, fail);
	
}


function fail(e)
{
	var msg = '';

	  switch (e.code) {
	    case FileError.QUOTA_EXCEEDED_ERR:
	      msg = 'QUOTA_EXCEEDED_ERR';
	      break;
	    case FileError.NOT_FOUND_ERR:
	      msg = 'NOT_FOUND_ERR';
	      break;
	    case FileError.SECURITY_ERR:
	      msg = 'SECURITY_ERR';
	      break;
	    case FileError.INVALID_MODIFICATION_ERR:
	      msg = 'INVALID_MODIFICATION_ERR';
	      break;
	    case FileError.INVALID_STATE_ERR:
	      msg = 'INVALID_STATE_ERR';
	      break;
	    default:
	      msg = 'Unknown Error';
	      break;
	  };

	  console.log('Error: ' + msg);
}