/**
	This FODD2015 program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
 **/



function servizi() 
{	
	this.results=null;
	this.legend=null;
	this.render=function(page,data)
	{
		var $this=this;
		this.results=JSON.parse( JSON.stringify( data ));
		data.legend=[
		          {"tipo":"Sensori Traffico","icon":"css/images/car.png"},
		          {"tipo":"Fermate Bus","icon":"css/images/busstop.png"},
		          {"tipo":"Servizi","icon":"css/images/marker-icon.png"},
		          ];
	};
	
	
	
	this.buildIcon=function (tipo)
	{
		var icon="";
		switch(tipo.toLowerCase())
		{
			case "sensorsites":
			case "sensori":
				icon=L.icon({
             	    iconUrl: 'css/images/car.png',
              	    iconRetinaUrl: 'css/images/car.png',
              	    iconSize: [32, 37]});
				break;
			case "busstops":
			case "fermate":
				icon=L.icon({
             	    iconUrl: 'css/images/busstop.png',
              	    iconRetinaUrl: 'css/images/busstop.png',
              	    iconSize: [32, 37]});
			break;
			/*case "servizi":
				icon=L.icon({
             	    iconUrl: 'css/images/lodging_0star.png',
              	    iconRetinaUrl: 'css/images/lodging_0star.png',
              	    iconSize: [32, 37]});
			break;*/
			
			case "servizi":	
			default:
					icon=L.icon({
			      	    iconUrl: 'css/images/marker-icon.png',
			      	    iconRetinaUrl: 'css/images/marker-icon.png',
			      	    iconSize: [25, 41],
			      	});
			break;
		}
		
		 
		return icon;
	};
	
	
	
	this.createMap=function()
	{
		if(document.documentElement.clientHeight<=640)
			$('#map').css("height","480px");
		else
			$('#map').css("height","720px");
		
		var $this=this;
		var map = L.map('map'); //.setView([43.7314,11.2884 ], 24);
		L.tileLayer('http://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png', {			
			}).addTo(map);
		var counter=0;
		 var iconsLayer=null;
		 for(var categoria in this.results)
		 {
			 if(this.results[categoria].features.length==0)
				 continue;
			 
			 iconsLayer = L.geoJson(this.results[categoria], {
					
                 
                 pointToLayer: function(feature, latlng) {
                  	var icon=$this.buildIcon(categoria); //feature.properties.tipo
                     return new L.Marker(latlng,{icon:icon});
                 },
                 onEachFeature: function(feature, layer){
                 	var type=feature.properties.typeLabel;
                 	counter++;
                     var divId=feature.id+"-"+type;
                     if(feature.properties.type!="fermata"){
                         contenutoPopup = "<h3>" + feature.properties.name.replace(/_/g," ") + "</h3>";
                      
                         contenutoPopup = contenutoPopup + "Tipologia: " + type.replace(/_/g," ") + "<br />";
                         if(feature.properties.email!="" && feature.properties.email)
                             contenutoPopup = contenutoPopup + "Email: " + feature.properties.email + "<br />";
                         if(feature.properties.address!="" && feature.properties.address)
                             contenutoPopup = contenutoPopup + "Indirizzo: " + feature.properties.address;
                         if(feature.properties.civic!="" && feature.properties.numero)
                             contenutoPopup = contenutoPopup + ", " + feature.properties.civic + "<br />";
                         else
                             contenutoPopup = contenutoPopup +"<br />";
                         if(feature.properties.note!="" && feature.properties.note)
                             contenutoPopup = contenutoPopup + "Note: " + feature.properties.note + "<br />";  
                         if(feature.properties.serviceUri!="" && feature.properties.serviceUri && (categoria!="SensorSites"))
                        	 contenutoPopup = contenutoPopup +"<h4 onclick=\"InfoManager.showInfoAboutOneMarker('" + feature.properties.serviceUri + "')\">More</h4>";
                         contenutoPopup=contenutoPopup+"<div id=\""+divId+"\" ></div>";
                         layer.addTo(map).bindPopup(contenutoPopup).openPopup();
                    
                     }
                    else{
                         var divLinee=divId+"-linee";
                         var  contenutoPopup = "<h3>FERMATA : " + feature.properties.name.replace(/_/g," ") + "</h3>";                                                                                  
                         contenutoPopup += "<div id=\""+divLinee+"\" ></div>";
                         contenutoPopup=contenutoPopup+"<div id=\""+divId+"\" ></div>";
                         layer.addTo(map).bindPopup(contenutoPopup).openPopup();
                    
                     }
                
            	 }
			
			}).addTo(map);
		 }
		
		if(iconsLayer){
			var confiniMappa = iconsLayer.getBounds();
			if(counter>1){
				
				//map.setView(confiniMappa.getCenter(),12);			
				map.fitBounds(confiniMappa);
				//map.setZoom(map.getBoundsZoom());
				//map.invalidateSize();
			}
			else
				map.setView(confiniMappa.getCenter(),14);	
			map.invalidateSize();
		}
		else
		{
			map.setView([43.7730,11.2563 ], 12);
			navigator.notification
			.alert("Nessun servizio trovato!");
		}
		//	
	}
}

